﻿using UnityEngine;
using System.Collections;
using Rewired;

public class ArmRotation : MonoBehaviour {

    PlayerMovement pm;
    Player player;
    float angle = 0;
    float lastAngle = 0;

    public int rotationOffset = 0;
	// Use this for initialization
    void Start ()
    {
        pm = GetComponent<PlayerMovement>();
        player = pm.player;
    }
	
	// Update is called once per frame
	void Update () {

        float x = player.GetAxis("Aim Horizontal");
        float y = player.GetAxis("Aim Vertical");

        if (!pm.canPlay)
        {
            x = 0;
            y = 0;
        }

        float rotZ;
        if (x == 0 && y == 0)
        {
            rotZ = lastAngle;
        }
        else
        {
            Vector2 padAngle = new Vector2(x, y).normalized;
            rotZ = Mathf.Atan2(padAngle.y, padAngle.x) * Mathf.Rad2Deg; // il per rad2deg converte
                                                                              // atan 2 Return value is the angle between the x-axis and a 2D vector starting at zero and terminating at (x,y).

            lastAngle = rotZ;
        }

        transform.rotation = Quaternion.Euler(0f,0f, rotZ + rotationOffset);

    }
}
