﻿using System.IO;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[ExecuteInEditMode]

public class ExportTiles : MonoBehaviour {

	public bool export = false;
	string doc = "";

	void Update () {

		if (!export)
			return;

		export = false;
		doc = "";

		try{
			foreach (Transform t in transform)
				doc += t.name+";"+t.transform.localPosition.x+";"+t.transform.localPosition.y+"\n";

			File.WriteAllText(Application.dataPath.Replace("Assets","")+"/TilesExport_"+GetTimestamp()+".txt",doc);
			Debug.Log("Export successfull.");
		}
		catch{
			Debug.Log("Could not export tiles.");
		}
	}

	int GetTimestamp () {

		return (int)(System.DateTime.UtcNow - new System.DateTime(1970,1,1,0,0,0)).TotalSeconds;
	}
}
