﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;

public class GameMaster : MonoBehaviour {

    public static GameMaster gm;


    public ArrayList listWasteland;

    public  int remainingLivesP1 = 3;
    public  int remainingLivesP2 = 3;


    void Awake()
    {
        if( gm == null)
        {
            gm = GetComponent<GameMaster>();
        }

        listWasteland = new ArrayList();


        foreach (Transform tile in GameObject.Find("Tiles").transform)
        {
            if (tile.name == "wasteland")
            {
                listWasteland.Add(tile);
                //print(tile.name);
            }
        }


    }

    public GameObject player1Prefab;
    public GameObject player2Prefab;


    public Transform spawnPointP1;
    public Transform spawnPointP2;

    public int spawnDelay = 2;
    public Transform spawnPrefab;

    //public CameraShake cameraShake;

    [SerializeField]
    private GameObject gameOverUI;

    void Start()
    {

        Init();
        /*
        if (cameraShake == null)
        {
            Debug.LogError("No camera Shake");
        }*/
        
    }

    public void Init()
    {
        remainingLivesP1 = 3;
        remainingLivesP2 = 3;

        //InitBattle();
        NextSpawnInTime();

        
    }

    public void InitBattle()
    {
        GameObject.Find("P1Win").GetComponent<CanvasGroup>().alpha = 0;
        GameObject.Find("P2Win").GetComponent<CanvasGroup>().alpha = 0;
        GameObject.Find("P1Wind").GetComponent<CanvasGroup>().alpha = 0;
        GameObject.Find("P2Wind").GetComponent<CanvasGroup>().alpha = 0;


        player1Prefab.GetComponent<PlayerMovement>().canPlay = true;
        player2Prefab.GetComponent<PlayerMovement>().canPlay = true;
        
        player1Prefab.transform.localPosition = spawnPointP1.localPosition;
        player2Prefab.transform.localPosition = GameObject.Find("SpawnPointP2").transform.localPosition;

        player1Prefab.transform.localRotation = spawnPointP1.localRotation;
        player2Prefab.transform.localRotation = GameObject.Find("SpawnPointP2").transform.localRotation;

        player1Prefab.transform.localScale = new Vector3(1, 1, 1);
        player2Prefab.transform.localScale = new Vector3(1, 1, 1);

        player1Prefab.GetComponent<Weapon>().isDead = false;
        player2Prefab.GetComponent<Weapon>().isDead = false;

        player1Prefab.GetComponent<Rigidbody2D>().drag = 1;
        player2Prefab.GetComponent<Rigidbody2D>().drag = 1;




    }

    public void NextSpawnInTime()
    {
        //print("SPAWWNNNN");

        
        if (GameMaster.gm.remainingLivesP2 <= 0 || GameMaster.gm.remainingLivesP1 <= 0)
        {
            GameMaster.gm.remainingLivesP1 = 3;
            GameMaster.gm.remainingLivesP1 = 3;
            GameObject.Find("TextLife2").GetComponent<Text>().text = "X 3";
            GameObject.Find("TextLife1").GetComponent<Text>().text = "X 3";
        }


        player1Prefab.transform.localPosition = spawnPointP1.localPosition;
        player2Prefab.transform.localPosition = GameObject.Find("SpawnPointP2").transform.localPosition;

        player1Prefab.transform.localRotation = spawnPointP1.localRotation;
        player2Prefab.transform.localRotation = GameObject.Find("SpawnPointP2").transform.localRotation;

        //remainingLivesP1 = 3;
        //remainingLivesP2 = 3;

        StartCoroutine("Countdown");
    }


    public void WaitWinScreen()
    {

        if (gm.remainingLivesP1 == 0 || gm.remainingLivesP2 == 0)
        {
            Invoke("NextSpawnInTime", 5.0f);
            GameObject.Find("P1Win").GetComponent<CanvasGroup>().alpha = 0;
            GameObject.Find("P2Win").GetComponent<CanvasGroup>().alpha = 0;
            //TODO : inserire text wind
            if (gm.remainingLivesP1 == 0){
                GameObject.Find("P2Wind").GetComponent<CanvasGroup>().alpha = 1;
            }

            if (gm.remainingLivesP2 == 0)
            {
                GameObject.Find("P1Wind").GetComponent<CanvasGroup>().alpha = 1;
            }

        }
        else
        {
            Invoke("NextSpawnInTime", 3.0f);
        }
    }

    IEnumerator Countdown ()
    {

        GameObject.Find("P1Win").GetComponent<CanvasGroup>().alpha = 0;
        GameObject.Find("P2Win").GetComponent<CanvasGroup>().alpha = 0;
        GameObject.Find("P1Wind").GetComponent<CanvasGroup>().alpha = 0;
        GameObject.Find("P2Wind").GetComponent<CanvasGroup>().alpha = 0;

        player1Prefab.GetComponent<PlayerMovement>().canPlay = false;
        player2Prefab.GetComponent<PlayerMovement>().canPlay = false;

        player1Prefab.transform.localPosition = spawnPointP1.localPosition;
        player2Prefab.transform.localPosition = GameObject.Find("SpawnPointP2").transform.localPosition;

        player1Prefab.transform.localRotation = spawnPointP1.localRotation;
        player2Prefab.transform.localRotation = GameObject.Find("SpawnPointP2").transform.localRotation;

        Camera main = Camera.main;
        main.GetComponent<CameraMovement2>().targets = new Transform[2];
        main.GetComponent<CameraMovement2>().boundingBoxPadding = 3;
        main.GetComponent<CameraMovement2>().minimumOrthographicSize = 6f;
        main.GetComponent<CameraMovement2>().zoomSpeed = 2;

        main.GetComponent<CameraMovement2>().targets[0] = GameObject.Find("Player_0").transform;
        main.GetComponent<CameraMovement2>().targets[1] = GameObject.Find("Player_1").transform;

        GameObject.Find("P1Win").GetComponent<CanvasGroup>().alpha = 0;
        GameObject.Find("P1Win").GetComponent<CanvasGroup>().alpha = 0;

        GameObject.Find("Life1").GetComponent<CanvasGroup>().alpha = 1;
        GameObject.Find("Life2").GetComponent<CanvasGroup>().alpha = 1;


        GameObject.Find("BattleText").GetComponent<CanvasGroup>().alpha = 1;
        GameObject.Find("BattleText").GetComponent<Text>().text = "GET READY";
        //print("3");

        yield return new WaitForSecondsRealtime(1f);

        GameObject.Find("BattleText").GetComponent<Text>().text = " 3";

        //print("2");

        yield return new WaitForSecondsRealtime(1f);

        GameObject.Find("BattleText").GetComponent<Text>().text = " 2";

        //print("1");

        yield return new WaitForSecondsRealtime(1f);

        GameObject.Find("BattleText").GetComponent<Text>().text = " 1";

        yield return new WaitForSecondsRealtime(1f);

        GameObject.Find("BattleText").GetComponent<Text>().text = "GO!";

        yield return new WaitForSecondsRealtime(1f);
        GameObject.Find("BattleText").GetComponent<CanvasGroup>().alpha = 0;
        //print("GO!");


        InitBattle();
    }



    /*

    public void EndGame()
    {
        Debug.Log("GAME OVER");
        gameOverUI.SetActive(true);
    }




    public IEnumerator _RespawnPlayer()
    {
        transform.GetComponent<AudioSource>().Play();
        yield return new WaitForSeconds(spawnDelay);
        Instantiate(playerPrefab, spawnPoint.position, spawnPoint.rotation);
        GameObject clone = Instantiate(spawnPrefab, spawnPoint.position, spawnPoint.rotation) as GameObject;
        Destroy(clone, 3f);
    }

    public static void KillPlayer(Player player)
    {
        Destroy(player.gameObject);
        _remainingLives -= 1;
        if(_remainingLives <= 0)
        {
            gm.EndGame();
        }
        else
        {
            gm.StartCoroutine(gm._RespawnPlayer());
        }
    }

    public static void KillEnemy(Enemy enemy)
    {
        gm._killEnemy(enemy);
        //gm.StartCoroutine(gm.RespawnPlayer());
    }

    public void _killEnemy(Enemy _enemy)
    {
        GameObject _clone = Instantiate(_enemy.deathParticles, _enemy.transform.position, Quaternion.identity) as GameObject;
        Destroy(_clone, 5f);
        cameraShake.Shake(_enemy.shakeAmt, _enemy.shakeLenght);
        Destroy(_enemy.gameObject);
    }
    */


    // Update is called once per frame
    void Update () {
	
	}
}
