﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GrassWind : MonoBehaviour {

	float angle;
	float gain;
	float randomGain;
	SpriteRenderer rend;
	float waveValue;
	float maxDelta = 0.08f;
	Vector2 additionalMovement;
	Vector2 tempMovement;
	Vector2 vTemp;

	void Start () {

		rend = GetComponent<SpriteRenderer>();
		randomGain = Random.Range(-4f,4f);
		InvokeRepeating("UpdateGrass",0f,1f/30f);
	}

	void UpdateGrass () {

		//Muovi l'erba in base al vento standard
		gain = ((transform.position.x * (-Mathf.Sin(WindManager.Instance.tempWindDirection * Mathf.Deg2Rad))) + (transform.position.y * (-Mathf.Cos(WindManager.Instance.tempWindDirection * Mathf.Deg2Rad)))) * (20 + randomGain);
		angle += WindManager.Instance.finalWindSpeed;
		angle = Mathf.Repeat(angle,360);
		waveValue = (1+Mathf.Sin(Mathf.Repeat(angle + gain,360) * Mathf.Deg2Rad)) / 2f;

		//Movimento morbido
		tempMovement = Vector2.SmoothDamp(tempMovement,additionalMovement,ref vTemp, 0.2f, Mathf.Infinity, 0.2f);

		//Assegna il movimento: in realtà il movimento del vento e quello addizionali dovrebbero essere mediati invece che sommati e basta, ma per ora va bene così, dai.
		transform.localPosition = Vector2.ClampMagnitude((WindManager.Instance.windVector * waveValue * WindManager.Instance.tempWindForce) + tempMovement, maxDelta);

		//Cambia il colore in base alla distanza dal centro
		float colorValue = Mathf.Pow(Mathf.Abs(transform.localPosition.x) + Mathf.Abs(transform.localPosition.y),2);
		rend.color = new Color(1,1,1,colorValue * 200);

		//Riduci lentamente il movimento extra
		additionalMovement *= 0.95f;
	}

	public void AddMovement (Vector2 force) {

		additionalMovement = Vector2.ClampMagnitude(additionalMovement + force, maxDelta);
	}
}
