﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[ExecuteInEditMode]

public class ImportTiles : MonoBehaviour {

	public TextAsset importData;
	public bool import = false;

	void Update () {

		if (!import)
			return;

		import = false;

		foreach(Transform t in transform)
			DestroyImmediate(t.gameObject);

		string[] tiles = importData.text.Split('\n');
		foreach (string tileData in tiles){

			if (string.IsNullOrEmpty(tileData))
				continue;

			string spriteName = tileData.Split(';')[0];
			float x = float.Parse(tileData.Split(';')[1]);
			float y = float.Parse(tileData.Split(';')[2]);

			GameObject tile = new GameObject();
			SpriteRenderer sr = tile.AddComponent<SpriteRenderer>();
			sr.sprite = Resources.Load<Sprite>("Sprites/Tiles/"+spriteName);
			if (sr.sprite.name.ToLower().Contains("wall") || sr.sprite.name.ToLower().Contains("object") || sr.sprite.name.ToLower().Contains("fence"))
				sr.sortingOrder = 2;
			else
				sr.sortingOrder = 0;
			tile.name = sr.sprite.name;
			tile.transform.SetParent(transform);
			tile.transform.localScale = Vector3.one;
			tile.transform.localPosition = new Vector3(x,y,0);
			tile.AddComponent<TileAutoSnap>();
		}

		Debug.Log("Tiles imported.");
	}
}
