﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ObjectManager : MonoBehaviour {

	[HideInInspector] public static ObjectManager Instance;
	private static bool _istantiated = false;

	public GameObject[] spawnableObjects;
	public GameObject[] spawnPoints;

	int cycle = 0;

	void Awake () {

		if (_istantiated){
			Destroy(this);
			return;
		}
		_istantiated = true;
		Instance = this;
	}

	void Start () {

		cycle = Random.Range(0,spawnPoints.Length);

		int count = 0;
		while (count < 10){
			SpawnObject();
			count++;
		}
	}

	public void SpawnObject () {

		GameObject spawnPoint = spawnPoints[cycle];
		GameObject obj = (GameObject)spawnableObjects[Random.Range(0,spawnableObjects.Length)];

		GameObject newObject = (GameObject)Instantiate(obj,spawnPoint.transform.position,Quaternion.identity);
		newObject.transform.position += new Vector3(Random.Range(-1f,1f), Random.Range(-1f,1f), 0);
		newObject.transform.localScale = newObject.transform.localScale * Random.Range(0.8f,1.2f);

		cycle++;
		cycle = Mathf.RoundToInt(Mathf.Repeat(cycle,spawnPoints.Length));
	}

	void OnDrawGizmos () {

		if (spawnPoints == null)
			return;

		if (spawnPoints.Length == 0)
			return;

		Gizmos.color = Color.blue;
		foreach (GameObject obj in spawnPoints)
			Gizmos.DrawWireSphere(obj.transform.position,0.5f);
	}
}