﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PrepareDynamicGrass : MonoBehaviour {

	void Awake () {

		foreach (Transform t in transform) {

			if (t.name.Contains("grass")){

				GameObject dynamicGrass = new GameObject();
				dynamicGrass.transform.SetParent(t);
				dynamicGrass.transform.localScale = Vector3.one;
				dynamicGrass.transform.localPosition = Vector3.zero;

				SpriteRenderer sr = dynamicGrass.AddComponent<SpriteRenderer>();
				sr.sprite = Resources.Load<Sprite>("Sprites/Tiles/DynamicGrass/"+t.GetComponent<SpriteRenderer>().sprite.name);
				sr.sortingOrder = 1;

				dynamicGrass.AddComponent<GrassWind>();
			}
		}
	}
}
