﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class WindTrail : MonoBehaviour {

	Rigidbody2D rb;
	Vector2 prevPosition;
	Vector2 delta;

	void Start () {

		TrailRenderer tr = GetComponent<TrailRenderer>();
		tr.sortingOrder = 3;
		rb = gameObject.GetComponent<Rigidbody2D>();
		rb.gravityScale = 0;
	}

	void Update () {

		/*rb.AddForce(new Vector2(Input.GetAxis("Horizontal")*20f, Input.GetAxis("Vertical")*20f));
		rb.drag = 1;*/

		delta = new Vector2(transform.position.x, transform.position.y) - prevPosition;
		prevPosition = new Vector2(transform.position.x, transform.position.y);
		CheckGrass();
		CheckFog();
	}

	void CheckGrass () {

		float threshold = 1.5f;
		foreach (GrassWind grassWind in WindManager.Instance.grassWinds){

			float distance = Vector2.Distance(new Vector2(transform.position.x, transform.position.y), new Vector2(grassWind.transform.position.x, grassWind.transform.position.y));
			if (distance < threshold){
				float push = 1f-(distance/threshold);
				grassWind.AddMovement((delta / 30f) * push);
			}
		}
	}

	void CheckFog () {

		float threshold = 4f;
		foreach (Rigidbody2D fog in WindManager.Instance.fogObjects){

			try{
				float distance = Vector2.Distance(new Vector2(transform.position.x, transform.position.y), new Vector2(fog.transform.position.x, fog.transform.position.y));
				if (distance < threshold){
					float push = 1f-(distance/threshold);
					fog.AddForce((delta * 30) * push);
				}
			}
			catch{}
		}
	}

	void OnDrawGizmos () {

		Gizmos.color = Color.white;
		Gizmos.DrawWireSphere(transform.position,0.1f);
	}
}
